#makedatfiles

#The script extracts information from the *.mu2 files in the mu2
#folder and writes them in the files title.dat, composer.dat,
#usuls.dat, and tempo.dat



# mcsplit --
#
#   Splits a string based using another string
#
# Arguments:
#   str       string to split into pieces
#   splitStr  substring
#   mc        magic character that must not exist in the orignal string.
#             Defaults to the NULL character.  Must be a single character.
# Results:
#   Returns a list of strings
#
proc mcsplit "str splitStr {mc {\x00}}" {
    return [split [string map [list $splitStr $mc] $str] $mc]
    }


proc extract_mu2_data {filename} {
   global usuldic tempodic titledic composerdic
   set nc51 0
   set nc52 0
   set nc56 0
   set tfilename [string range $filename 0 [expr [string length $filename] - 5]]
   set inhandle [open $filename]
   set filenamelist [mcsplit $filename "--"]
   set usul [lindex $filenamelist 2]
   while {![eof $inhandle]} {
       gets $inhandle line
       set linelist [split $line "\t"]
       if  {[lindex $linelist 0] == "51"} {
                                           set num [lindex $linelist 2]
                                           set denom [lindex $linelist 3]
                                           set usuldic($tfilename) $num/$denom
                                           incr nc51 
                                           #puts "$usul\t$num/$denom"
                                          }
       if  {[lindex $linelist 0] == "52"} {set tempo [lindex $linelist 4]
                                           #puts $linelist
                                           set tempodic($tfilename) $tempo
                                           incr nc52
                                          }
       if  {[lindex $linelist 0] == "56"} {
                                           set num [lindex $linelist 2]
                                           set denom [lindex $linelist 3]
                                           set usuldic($tfilename) $num/$denom
                                           incr nc56
                                           #puts "$usul\t$num/$denom"
                                           }
       if  {[lindex $linelist 0] == "58"} {set composer [lindex $linelist 7]
                                           set composerdic($tfilename) $composer
                                           #puts $composer
                                          }
       if  {[lindex $linelist 0] == "60"} {set title [lindex $linelist 7]
                                           set titledic($tfilename) $title
                                           #break
                                          }
       }
      
   close $inhandle
   if {$nc51 > 1} {puts "$nc51 kod 51 settings for $filename"}
   if {$nc56 > 0} {puts "$nc56 kod 56 settings for $filename"}
   }

global usuldic tempodic titledic composerdic

cd "mu2"
set filelist [glob *.mu2]
foreach filename $filelist {
   extract_mu2_data $filename
   }
cd "../."
set outhandle [open "usuls.dat" "w"]
foreach filename [array names usuldic] {
    puts $outhandle "$filename\t$usuldic($filename)"
    }
close $outhandle

set outhandle [open "tempo.dat" "w"]
foreach filename [array names tempodic] {
    puts $outhandle "$filename\t$tempodic($filename)"
    }
close $outhandle

set outhandle [open "title.dat" "w"]
foreach filename [array names titledic] {
    puts $outhandle "$filename\t$titledic($filename)"
    }
close $outhandle

set outhandle [open "composer.dat" "w"]
foreach filename [array names composerdic] {
    puts $outhandle "$filename\t$composerdic($filename)"
    }
close $outhandle


