#splitmakamfile.tcl

#After running sym2abc.tcl, you will have a collection of 2200 abc
#files in the abc subfolder. Concatenate them all to one file using
#the command.
# cat *.abc > ../makams.abc
#Load makams.abc in runabc.tcl, order the tunes in alphabetical
#order by title, and copy the entire collection to another file,
#makamu.abc renumbering the tunes sequentially.
#Place makamu.abc in the same folder as splitmakamfile.tcl and
#ensure that the subfolder splitmakams exist. Finally, run this
#script.
#tclsh splitmakamfile.tcl
#The folder splitmakams will contain 22 makamu*.abc files, each
#containing 100 abc tunes and a header in the beginning defining
#the special PostScript symbols for the different microtones.

set inhandle [open "makamu.abc" "rb"]
set outdir "splitmakams"

set line " "
set n 0

set outfile $outdir/makamu$n.abc
set outhandle [open $outfile "wb"]

set header "
I:abc-charset utf-8
%%beginps
/micronewps {1}
/sbar {M -3.0 4.0 rmoveto 4.0 4.3 rlineto stroke}!
/hbar {M -3.0 -1.0 rmoveto 6.0 1.5 rlineto stroke}!
/num2 {M 2.0 6.0 rmoveto /Times-Roman 10 selectfont (2) show}!
/num3 {M 4.0 6.0 rmoveto /Times-Roman 10 selectfont (3) show}!
/ft1543  {2 copy ft0 sbar}! %_7/8
/ft515 {ft1543}! %_3/4
/ft3{gsave -1 1 scale exch neg exch ft0 grestore}!
/ft259 {2 copy ft3}! %_2/4
/sh3 {2 copy sh1}! %_1/4
/sh259 {2 copy sh1}! %^2/4
/sh515 { 2 copy sh0}! %^3/4
/sh2055 {2 copy sh1 hbar}! % ^9/8
%%endps
"

puts $outhandle $header


while {[eof $inhandle] != 1} {
    gets $inhandle line
    if {[string index $line 0] == "X"} {
        scan $line "X: %d" ref
        set m [expr $ref / 100]
        if {$m != $n} {
           close $outhandle
           set n $m
           set outfile $outdir/makamu$n.abc
           set outhandle [open $outfile "wb"]
           puts $outhandle $header
           puts $n
           }
        }
    puts $outhandle $line
   }

close $outhandle


           
